import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

class Oaid {
  static const MethodChannel _channel = MethodChannel('flutter_oaid_cn');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String?> get oaid async {
    if (defaultTargetPlatform == TargetPlatform.android) {
      final String? oaidvalue = await _channel.invokeMethod('getOAID');
      return oaidvalue;
    }
    return '';
  }

  static Future<String> register() {
    if (defaultTargetPlatform == TargetPlatform.android) {
      return _channel
          .invokeMethod<String>('register')
          .then((value) => value ?? '');
    }
    return Future.value('');
  }

  static Future<String?> get androidId async {
    if (defaultTargetPlatform == TargetPlatform.android) {
      final String? androidIdvalue =await _channel.invokeMethod('getAndroidId');
      return androidIdvalue;
    }
    return '';
  }

  static Future<bool> isSupport() {
    if (defaultTargetPlatform == TargetPlatform.android) {
      return _channel
          .invokeMethod<bool>('isSupport')
          .then((value) => value ?? false);
    }
    return Future.value(false);
  }
}
